;        ***************************************
;         This program was written using ASMPRO
;         and requires the GEMDOS & XBIOS lib.
;        ***************************************
;        adapted to either medrez or hirez boot!
;        ported to atari-st  w/mac.tos CJPurcell
;         ilabel tos\tos.l for July '88 D.O.M 
          text
dmamode   equ      $FF8606            ; Used to set DMA mode (ie. FDC/HDC)
dmadat    equ      $FF8604            ; Read status or write command here
flock     equ      $43e 
          move.w   #4,-(sp)           ;public domain medrez.s  1985
	  trap	   #14	              ; XBIOS #4 - getrez
	  addq.l   #2,sp

	  cmpi.l   #2,d0	      ; Monochrome monitor?
	  beq	   hirez	      ; Yes, skip ahead
                                        
          move     #1,-(a7)           ; Set screen resolution to medium
          move     #2,-(a7)           ;physbase:Get the physical screen base
          trap     #14
          addq.l   #2,a7
          move.l   d0,-(a7)
          move     #3,-(a7)           ;logbase:Get the logical screen base
          trap     #14
          addq.l   #2,a7
          move.l   d0,-(a7)
          move     #5,-(a7)           ; Change REZ to Med.if in color...
          trap     #14
          move     #0,-(a7)
                                      ;setcolor 
          move     #3,-(a7)           ; Set character color to black
          move     #7,-(a7)
          trap     #14
          addq.l   #6,a7
hirez:
          pea      ptext              ;printline
          move     #9,-(a7)
          trap     #1
          addq.l   #6,a7
           
          bsr      do_sup             ; Gotta do this in supervisor mode
     
          move     #$80,dmamode       ; Select FDC/HDC {Note: Flock set}
          bsr      wait_alittle

          move     dmadat,d3         ; Get controller status
          btst     #7,d3             ;Is the motor on?
          bne      flpstp
          bsr      do_usr            ;No. Leave!
          bra      depart

flpstp:
          bsr      do_usr            ;Go back to user mode for rest
                                     ;conout
          move     #7,-(a7)
          move     #2,-(a7)
          trap     #1
          addq.l   #4,a7
                                     ;getbpb
          move     #0,-(a7)
          move     #7,-(a7)
          trap     #13
          addq.l   #4,a7
          bra      depart            ;Exit #1

wait_alittle:                        ;wait approximately .01 millaseconds
          move     sr,-(sp)
          move     #40,d7
w_altl: 
          dbra     d7,w_altl
          move     (sp)+,sr
          rts

do_sup:                              ;Go into SUPERVISOR mode
          clr.l    -(sp)
          move     #$20,-(sp)
          trap     #1
          addq.l   #6,sp
          move.l   d0,usstack
          rts

do_usr:
          move.l   usstack,-(sp)
          move     #$20,-(sp)
          trap     #1
          addq.l   #6,sp
          rts
          
depart:
;term
          clr.l    -(sp)
          trap     #1
          addq.l   #2,sp

          data

;         Remember.... This must be in the program!!!

ptext:    dc.b     '             FlopStop Ver. II',10,13
          dc.b     '         MADE PUBLIC DOMAIN 7/3/88',10,13
          dc.b     '           = 1988 ACF Services',10,13,10,0

          bss

usstack:
          ds.l     1

          end
